
/** D E C L A R A T I O N S **************************************************/

typedef enum {FALSE, TRUE} BOOL;


// *******************************    Drucksensor HP03MA  ****************************
// supply 2.2 bis 3.6 Volt
// XCLR is to reset the AD converter (active low). 
// XCLR should be set to high only during AD conversion phase (reading D1,D2), 
// at all other states, such as reading calibration factors, this pin should be kept low.
//#define HP03SA_MCLK	 // wird durch PWM realisiert
#define HP03SA_XCLR  PORTCbits.RC6

// I2C Addresses:
#define HP03_write_addr		0xEE	// Drucksensor schreiben 
#define HP03_read_addr		0xEF	// Drucksensor lesen
#define HP03_EEPROM_addr_read	0xA1
#define HP03_EEPROM_addr_write	0xA0
#define low 0x00
#define hight 0x01
#define yes 0
#define no 1
#define Roh_Druck 0xF0
#define Roh_Temperatur 0xE8


typedef unsigned int    word;           // 16-bit

typedef union _WORD
{
    word _word;
    struct
    {
        unsigned char LowB;
        unsigned char HighB;
    };
} WORD;


// Datenstrucktur
typedef union tagHP03SA {

		struct {
			signed int D1;			// 16 bit
			signed int D2;			// 16 bit
			// koeffizeinten (beim Start auslesen)
			signed int C1;			// 16 bit
			signed int C2;			// 
			signed int C3;			// 
			signed int C4;			// 
			signed int C5;			// 
			signed int C6;			// 
			signed int C7;			// 
			// sensor parameter (beim Start auslesen)
			unsigned char AA;		//  1..63, 8 bit
			unsigned char BB;		//  1..63
			unsigned char CC;		//  1..15
			unsigned char DD;		//  1..15
			// entgltige Werte
			signed long  Druck_hPa;		// hPa *10
			signed short Temp_C;		// Grad Celsius *10
			signed long  Hoehe_dm;		// dm
		};
		struct {
			WORD		wD1;
			WORD		wD2;
			// 
			WORD 		wC1;			// 16 bit
			WORD 		wC2;			// 
			WORD 		wC3;			// 
			WORD 		wC4;			// 
			WORD 		wC5;			// 
			WORD 		wC6;			// 
			WORD 		wC7;			// 
		};
}	_HP03SA;
